#include "../api.h"
#include <stdio.h>	/* sprintf */

#define INVALID	-0x7fffffff
int strtol(char *s, char **endp, int base);	/* stdlib.h */
void sskip(unsigned char **p);
int calc(unsigned char **p, int pri);

void HariMain(void)
{
	unsigned char line[30], *p;
	int i;

	api_cline(line + 1, 30);
	p = line;
	i = calc(&p, 9);
	if (i == INVALID) {
		api_puts("vZł܂B", -1);
	} else {
		sprintf(line, "= %d = 0x%x", i, i);
		api_puts(line, -1);
	}
	return;
}

void sskip(unsigned char **p)
{
	for (; **p == ' '; (*p)++) { }
	return;
}

int calc(unsigned char **p, int pri)
{
	int i = INVALID, j;

	sskip(p);
	/* PZq */
	if (**p == '+') {
		(*p)++;
		sskip(p);
		i = calc(p, 0);
	} else if (**p == '-') {
		(*p)++;
		sskip(p);
		i = calc(p, 0);
		if (i != INVALID) {
			i = -i;
		}
	} else if (**p == '~') {
		(*p)++;
		sskip(p);
		i = calc(p, 0);
		if (i != INVALID) {
			i = ~i;
		}
	} else if (**p == '(') {
		(*p)++;
		sskip(p);
		i = calc(p, 9);
		if (**p == ')') {
			(*p)++;
			sskip(p);
		} else {
			i = INVALID;
		}
	} else if ('0' <= **p && **p <= '9') {
		i = strtol(*p, (char **) p, 0);
	} else {
		i = INVALID;
	}

	/* 񍀉Zq */
	for (;;) {
		if (i == INVALID) {
			break;
		}
		sskip(p);
		if (**p == '+' && pri >= 2) {
			(*p)++;
			sskip(p);
			j = calc(p, 2);
			if (j != INVALID) {
				i += j;
			} else {
				i = INVALID;
			}
		} else if (**p == '-' && pri >= 2) {
			(*p)++;
			sskip(p);
			j = calc(p, 2);
			if (j != INVALID) {
				i -= j;
			} else {
				i = INVALID;
			}
		} else if (**p == '*' && pri >= 1) {
			(*p)++;
			sskip(p);
			j = calc(p, 1);
			if (j != INVALID) {
				i *= j;
			} else {
				i = INVALID;
			}
		} else if (**p == '/' && pri >= 1) {
			(*p)++;
			sskip(p);
			j = calc(p, 1);
			if (j != INVALID && j != 0) {
				i /= j;
			} else {
				i = INVALID;
			}
		} else if (**p == '%' && pri >= 1) {
			(*p)++;
			sskip(p);
			j = calc(p, 1);
			if (j != INVALID && j != 0) {
				i %= j;
			} else {
				i = INVALID;
			}
		} else if (**p == '<' && *(*p + 1) == '<' && pri >= 3) {
			*p += 2;
			sskip(p);
			j = calc(p, 3);
			if (j != INVALID && j != 0) {
				i <<= j;
			} else {
				i = INVALID;
			}
		} else if (**p == '>' && *(*p + 1) == '>' && pri >= 3) {
			*p += 2;
			sskip(p);
			j = calc(p, 3);
			if (j != INVALID && j != 0) {
				i >>= j;
			} else {
				i = INVALID;
			}
		} else if (**p == '&' && pri >= 4) {
			(*p)++;
			sskip(p);
			j = calc(p, 4);
			if (j != INVALID) {
				i &= j;
			} else {
				i = INVALID;
			}
		} else if (**p == '^' && pri >= 5) {
			(*p)++;
			sskip(p);
			j = calc(p, 5);
			if (j != INVALID) {
				i ^= j;
			} else {
				i = INVALID;
			}
		} else if (**p == '|' && pri >= 6) {
			(*p)++;
			sskip(p);
			j = calc(p, 6);
			if (j != INVALID) {
				i |= j;
			} else {
				i = INVALID;
			}
		} else {
			break;
		}
	}
	sskip(p);
	return i;
}
